/* $Id: config.h 18 2023-04-20 13:31:25Z nishi $ */
#ifndef __SWINEHUB_CONFIG_H__
#define __SWINEHUB_CONFIG_H__

#define SWINEHUB_DEFAULT_SERVER		"127.0.0.1"
#define SWINEHUB_DEFAULT_PORT		80
#define SWINEHUB_DEFAULT_PREFIX		"/svn"
#define SWINEHUB_DEFAULT_PATH		"/var/svn"
#define SWINEHUB_DEFAULT_CACHEPATH	"/var/svn-cache"
#define SWINEHUB_DEFAULT_CSSPATH	"/style.css"
#define SWINEHUB_DEFAULT_ICONPATH	"/icon.png"
#define SWINEHUB_DEFAULT_ITWORKS	1
#define SWINEHUB_DEFAULT_SCRIPTPATH	"/script.js"
#define SWINEHUB_DEFAULT_SVN		"/usr/pkg/bin/svn"
#define SWINEHUB_DEFAULT_SVNADMIN	"/usr/pkg/bin/svnadmin"
#define SWINEHUB_DEFAULT_HTPASSWD	"/usr/pkg/bin/htpasswd"
#define SWINEHUB_DEFAULT_SIGNUP		0

struct swinehub_config {
	char* server;
	int port;
	char itworks;
	char* prefix;
	char* path;
	char* csspath;
	char* iconpath;
	char* scriptpath;
	char* cachepath;
	char* svn;
	char* svnadmin;
	char* htpasswd;
	int signup;
};

struct swinehub_config* swinehub_parse_config(const char* path);
void swinehub_free_config(struct swinehub_config* config);

#endif
